#This function should handle all weights and spawning conditions, returns spawn id

#Global roll for all uses, never roll twice
execute store result score spawning_roll astro_game.obstacles run random value 1..100

## Asteroids for laser portal 
execute if score laser_fuel astro_game.powerups matches 10.. run return -1 

## Collectable portal
execute if score collectable_fuel astro_game.powerups matches 10.. run return 11


## Boost portals 
execute if score boost_fuel astro_game.powerups matches 30.. if score spawning_roll astro_game.obstacles matches ..50 run return 4
execute if score boost_fuel astro_game.powerups matches 30.. unless score spawning_roll astro_game.obstacles matches ..50 run return 3



## Default
execute if score preset astro_game.persistent matches 0 run return run function astro_game:obstacles/actions/spawning_presets/tutorial
execute if score preset astro_game.persistent matches 1 run return run function astro_game:obstacles/actions/spawning_presets/normal
execute if score preset astro_game.persistent matches 2 run return run function astro_game:obstacles/actions/spawning_presets/zen
execute if score preset astro_game.persistent matches 3 run return run function astro_game:obstacles/actions/spawning_presets/hard

return -1
