#This function should run as an entity with the tag "obstacle"

#return if the entity is not destructable
execute if entity @s[tag=non_lethal_obstacle] run return 0

execute store result score subject_z astro_game.projectiles run data get entity @s Pos[2] 10000

execute unless predicate astro_game:projectile_z_check run return 0

execute positioned as @s run particle explosion ~ ~ ~ 0 0 1 1 1 force
execute positioned as @s run particle snowflake ~ ~ ~ 0 0 0 1 100 force
execute positioned as @s run kill @e[tag=projectile,sort=nearest,limit=1]
execute as @s run function astro_game:obstacles/actions/award_score

#handle shielded spaceship
execute if entity @s[tag=shielded] run playsound sounds:shield_off master @a[tag=game_viewer] ~ ~ ~ 1 1 1
execute if entity @s[tag=yellow_spaceship,tag=!shielded] run playsound sounds:explosion_red master @a[tag=game_viewer] ~ ~ ~ 1 1 1


#Handle asteroid
execute if entity @s[tag=asteroid] run playsound sounds:asteroid_hit master @a[tag=game_viewer] ~ ~ ~ 1 1 1

#Handle blue spaceship
execute if entity @s[tag=blue_spaceship] run playsound sounds:blue master @a[tag=game_viewer] ~ ~ ~ 1 1 1


#handle red spaceship
execute if entity @s[tag=red_spaceship] run playsound sounds:explosion_red master @a[tag=game_viewer] ~ ~ ~ 1 1 1

#handle laser portal buff
execute if score laser_fuel astro_game.powerups matches 1.. run kill @s

#handle orange spaceship
execute if entity @s[tag=orange_spaceship] positioned as @s positioned ~-15 ~-5 ~-3 as @e[tag=obstacle,tag=!asteroid,dx=30,dy=10,dz=6] run kill @s
execute if entity @s[tag=orange_spaceship] positioned as @s run playsound sounds:explosion_orange master @a[tag=game_viewer] ~ ~ ~ 1 1 1


#handle yellow spaceship
execute if entity @s[tag=yellow_spaceship,tag=shielded] as @s run return run function astro_game:obstacles/actions/yellow_spaceship/shield_down


execute as @s if entity @s[tag=valid_target] run kill @s
