#This function should be run as an entity with the tag "turret_input_box"
execute if score message_skip_cooldown astro_game.tutorial matches 1.. run scoreboard players remove message_skip_cooldown astro_game.tutorial 1
execute as @s if data entity @s interaction run function astro_game:obstacles/actions/spawning_presets/tutorial/process_input


#if no player left-clicked, return
execute unless data entity @s attack run return 0

#Reset attack value to allow more left clicks
data remove entity @s attack 

#check for sufficent energy 
execute if score force_recharge_fuel astro_game.turret matches 1.. run return run playsound sounds:no_ammo master @a[tag=game_viewer] ~ ~ ~ 1 1 1
execute if score energy_fuel astro_game.turret matches ..0 run return run playsound sounds:no_ammo master @a[tag=game_viewer] ~ ~ ~ 1 1 1

#summon projectile
playsound sounds:gun master @a[tag=game_viewer] ~ ~ ~ 1 1 1
execute positioned as @e[tag=spaceship_turret,limit=1] run function astro_game:spaceship/entities/turret/projectile

#remove energy costs 
scoreboard players operation energy_fuel astro_game.turret -= laser_cost astro_game.turret

#punish if used all energy
execute if score energy_fuel astro_game.turret matches ..-1 run scoreboard players operation force_recharge_fuel astro_game.turret = max_force_recharge_fuel astro_game.turret
execute if score energy_fuel astro_game.turret matches ..-1 run playsound sounds:reload_energy master @a[tag=game_viewer] ~ ~ ~ 1 1 1
execute if score energy_fuel astro_game.turret matches ..-1 run scoreboard players set energy_fuel astro_game.turret 0
